#include <string.h>
#include <stdlib.h>
#include <stdio.h>

#include "dvd.h"

#define DEBUG 0 

typedef struct node node;

struct node {
    dvd *thedvd;
    node *next;
};

node *dvds = NULL; /* pointer to beginning of dvd collection */

void free_mem() {
   /* free(newdvd);
    free(newnode);
    free(dvdbackup);
    free(token); */
}

/* recursively free */
void clear_dvds(node *thedvds) {
    if(dvds == NULL) {
        thedvds = dvds;
    }
    if(dvds->next != NULL) {
        clear_dvds(dvds->next);
        free(dvds);
    }
    free(dvds);
}

void add_dvd(char *line) {
    int i=0; /* Loop Index */
    int j=0; /* Token Index */
    int k=1; /* DVD Field Index */

    dvd *newdvd = malloc(sizeof(dvd));
    node *newnode = malloc(sizeof(node));
    node *dvdbackup = malloc(sizeof(node)); /* backup the beginning */

    char *token = NULL;
    int finished = 0;

    while((finished != 1)) {
        if((line[i] == ':') || (line[i] == '\0')) {

            switch (k) {
                case 1:
                    newdvd->id = token;
                    break;
                case 2:
                    newdvd->title = token;
                    break;
                case 3:
                    newdvd->genre = token;
                    break;
                case 4:
                    newdvd->age_rating = token;
                    break;
            }
            k++;
            j=0;

            token = NULL;

            if(line[i] == '\0') {
                finished = 1;
            }
        } else {
            if(token == NULL) {
                token = malloc(2);
                token[j] = line[i];
                token[j+1] = '\0';
            } else {
                token = realloc(token,j+2);
                token[j] = line[i];
                token[j+1] = '\0';
            }
            j++;
        }
        i++;
    }

    /* start putting the dvds into nodes and linking them together */
    newnode->thedvd = newdvd;
    if(dvds == NULL) {
        dvds = newnode;
    } else {
        dvdbackup = dvds;
        while(dvds->next != NULL) {
            dvds = dvds->next;
        }
        dvds->next = newnode;
        dvds = dvdbackup;
    }
}

void print_dvds() {
    node *thisnode;
    int finished = 0;
    thisnode = dvds;
    printf("[DVDs IN STOCK]\n\n");
    while(!finished) {
        printf("%s - \"%s\", %s, Cert: %s\n",thisnode->thedvd->id,thisnode->thedvd->title,thisnode->thedvd->genre,thisnode->thedvd->age_rating);
        if(thisnode->next != NULL) {
            thisnode = thisnode->next;
        } else {
            finished = 1;
        }
    }
}

dvd *find_dvd(int id) {
    node *thisnode = dvds;
    dvd *thisdvd = NULL;
    int finished = 0;
    int currid;

    while(!finished) {
        currid = atoi(thisnode->thedvd->id);
        if(currid == id) {
            finished = 1;
            thisdvd = thisnode->thedvd;
        } else {
            if(thisnode->next != NULL) {
                thisnode = thisnode->next;
            } else {
                finished = 1;
                thisdvd = NULL;
            }
        }
    }
    return thisdvd;
}
