#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "loan.h"
#include "dvd.h"
#include "borrower.h"
#include "fileio.h"

#define DEBUG 0

node *firstnode = NULL; /* location of first loan */

void do_filesave() {
    int finished = 0;
    node *thisnode;
	thisnode = firstnode;

#if DEBUG
    printf("thisnode: %s\n",thisnode);
#endif	

    clearfile();
	
	if(thisnode == NULL) {
	    finished = 1;
	}
	
    while(!finished) {
        if(thisnode->next != NULL) {
            writeline(thisnode->theloan->borrid,thisnode->theloan->dvdid);
            thisnode = thisnode->next;
        } else {
            writeline(thisnode->theloan->borrid,thisnode->theloan->dvdid);
            finished = 1;
        }
    }
}

void add_loan(char *dvdid, char *borrid) {
    loan *theloan = calloc(1,sizeof(loan));
    node *newnode = calloc(1,sizeof(node));
    node *firstbackup = calloc(1,sizeof(node));
	
#if DEBUG
    printf("firstnode: %s\n",firstnode);
#endif
	
    firstbackup = firstnode;

    theloan->borrid = borrid;
    theloan->dvdid = dvdid;

    newnode->theloan = theloan;

    if(firstnode == NULL) {
        firstnode = newnode;
    } else {
        while(firstnode->next != NULL) {
            firstnode = firstnode->next;
        }
        firstnode->next = newnode;
		newnode->next = NULL;
		if(firstbackup != NULL) {
            firstnode = firstbackup;
		}
    }
#if DEBUG
    printf("\nDVD %s is loaned to member %s\n",newnode->theloan->dvdid,newnode->theloan->borrid);
#endif
}

int return_loan(char *dvdid, char *borrid) {
    node *firstbackup;
    node *parentnode;
    int success = 0, finished = 0;
    firstbackup = firstnode;
    parentnode = NULL;

    while(!finished) {
        if((atoi(firstnode->theloan->dvdid) == atoi(dvdid)) && (atoi(firstnode->theloan->borrid) == atoi(borrid))) {
            if(firstnode->next != NULL) {
                if(parentnode != NULL) {
                    parentnode->next = firstnode -> next;
					firstnode = firstbackup;
                } else {
                    firstnode = firstnode->next;
                }
            } else {
                if(parentnode != NULL) {
                    parentnode->next = NULL;
					if(firstnode != firstbackup) {
					    firstnode = firstbackup;
					} else {
					    firstnode = NULL;
					}
                } else {
					firstnode = NULL;
                }
            }
            success = 1;
            finished = 1;
        } else {
            if(firstnode->next != NULL) {
                parentnode = firstnode;
                firstnode = firstnode->next;
            } else {
                finished = 1;
            }
        }
    }
#if DEBUG
    printf("\nfirstnode (at end of return loan): %s\n",firstnode);
#endif
    return success;
}

void read_loan(char *line) {
    int i=0; /* Loop Index */
    int j=0; /* Token Index */
    int k=1; /* Loan Field Index */

    loan *newloan = malloc(sizeof(loan));
    node *newnode = malloc(sizeof(node));
    node *firstbackup = malloc(sizeof(node)); /* backup the beginning */

    char *token = NULL;
    int finished = 0;

    while((finished != 1)) {
        if((line[i] == ':') || (line[i] == '\0')) {

            switch (k) {
                case 1:
                    newloan->borrid = token;
                    break;
                case 2:
                    newloan->dvdid = token;
                    break;
            }
            k++;
            j=0;

            token = NULL;

            if(line[i] == '\0') {
                finished = 1;
            }
        } else {
            if(token == NULL) {
                token = malloc(2);
                token[j] = line[i];
                token[j+1] = '\0';
            } else {
                token = realloc(token,j+2);
                token[j] = line[i];
                token[j+1] = '\0';
            }
            j++;
        }
        i++;
    }

    newnode->theloan = newloan;
    if(firstnode == NULL) {
        firstnode = newnode;
    } else {
        firstbackup = firstnode;
        while(firstnode->next != NULL) {
            firstnode = firstnode->next;
        }
        firstnode->next = newnode;
        firstnode = firstbackup;
    }
}

loan *find_loan(char *dvdid, char *borrid) {
    node *thisnode = firstnode;
    loan *thisloan = NULL;
    int finished = 0;
    int currid;

	if(thisnode == NULL) {
	    finished = 1;
		/* If the list is empty, don't search! */
	}
	
    while(!finished) {
        currid = atoi(thisnode->theloan->dvdid);
        if(currid == atoi(dvdid)) {
            finished = 1;
            thisloan = thisnode->theloan;
        } else {
            if(thisnode->next != NULL) {
                thisnode = thisnode->next;
            } else {
                finished = 1;
                thisloan = NULL;
            }
        }
    }
    return thisloan;
}

void print_loans() {
    node *thisnode;
    int finished = 0;
    thisnode = firstnode;
    printf("[Current Loans]\n\n");
    if(firstnode != NULL) {
        while(!finished) {
            printf("DVD %s is loaned to member %s\n",thisnode->theloan->dvdid,thisnode->theloan->borrid);
            if(thisnode->next != NULL) {
                thisnode = thisnode->next;
            } else {
                finished = 1;
            }
        }
    }
}

int loan_count(int borrid) {

    node *thisnode = firstnode;
    int finished = 0;
    int currid = 0;
    int counter = 0;

#if DEBUG
    printf("\n%d\n",borrid);
#endif
    if(thisnode == NULL) {
	    finished = 1;
	}
    while(!finished) {
        currid = atoi(thisnode->theloan->borrid);
        if(currid == borrid) {
            counter++;
        } 
        if(thisnode->next != NULL) {
            thisnode = thisnode->next;
        } else {
            finished = 1;
        }

    }
#if DEBUG
    printf("\n%d\n",counter);
#endif
    return counter;
}
