#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "ui.h"
#include "dvd.h"
#include "borrower.h"
#include "loan.h"
#include "fileio.h"

#define DEBUG 0

int dvdlimit = 0;

void pause() {
    char input = '0';

    if (getc(stdin) == '\n') {
        input = '0';
    }
    while(input != '\n') {
        
        printf("\nPress enter to return to the main menu...\n");
        input = getc(stdin);
    }
    system("clear");
}

int get_input() {
    int ok,input;
    ok = 0;
    input = 0;
    while (!ok) {
        printf("> ");
        if((scanf("%d",&input)) == 1) {
            ok=1;
	    break;
	} else {
	    fprintf(stderr,"Error!\n");
        }
    }
    return input;
}

borrower *get_borr() {
    borrower *thisborrower = NULL;
    while(thisborrower == NULL) {
        printf("\nPlease enter your user ID");
        thisborrower = find_borr(get_input());
        if(thisborrower  == NULL) {
            fprintf(stderr,"\nInvalid ID. Please try again.\n");
        }
    }
    return thisborrower;
}

dvd *get_dvd() {
    dvd *thisdvd = NULL;
    while(thisdvd == NULL) {
        printf("\nPlease enter the ID of the DVD");
        thisdvd = find_dvd(get_input());
        if(thisdvd == NULL) {
            fprintf(stderr,"\nInvalid ID. Please try again.\n");
        }
    }
    return thisdvd;
}

void borrow_menu() {
    borrower *thisborrower = get_borr();
    dvd *thisdvd = get_dvd();
    loan *thisloan = NULL;
	
    thisloan = find_loan(thisdvd->id,thisborrower->id);

#if DEBUG
    printf("On loan: %d, Max: %d\n",loan_count(atoi(thisborrower->id)),dvdlimit);
#endif

    if((loan_count(atoi(thisborrower->id))) < dvdlimit) {
        if(atoi(thisborrower->age) >= atoi(thisdvd->age_rating)) {
            if(thisloan == NULL) {
#if DEBUG
                printf("About to add loan...");
#endif
                add_loan(thisdvd->id,thisborrower->id);
                do_filesave();
                printf("\n%s has borrowed \"%s\" from the %s section.\n",thisborrower->name,thisdvd->title,thisdvd->genre);
            } else {
                printf("\nDVD %s has already been loaned to member %s.\n",thisloan->dvdid,thisloan->borrid);
            }
        } else {
            printf("\nYou are not old enough to borrow this DVD.\n");
        }
    } else {
        printf("\nYou are already borrowing the maximum number of DVDs allowed.\n");
    }
}

void return_menu() {
    borrower *thisborrower = get_borr();
    dvd *thisdvd = get_dvd();
	
    int success = return_loan(thisdvd->id,thisborrower->id);
	
    if(success) {
        do_filesave();
#if DEBUG
        printf("\nFile has been saved.\n");
#endif
        printf("\n%s has returned \"%s\" to the %s section.\n",thisborrower->name,thisdvd->title,thisdvd->genre);
    } else {
        printf("\nYou cannot return that DVD as you have not loaned it.\n");
    }
}

void main_menu() {
    int i;
    printf("\n*** DVD LIBRARY ***\n");
    printf("\nPlease select an option:\n\n");
    printf("\t1. Borrow a DVD\n");
    printf("\t2. Return a DVD\n");
    printf("\t3. View DVDs\n");
    printf("\t4. View Members\n");
    printf("\t5. View Loans\n");
    printf("\t6. Credits\n");
    printf("\t7. Exit\n");
    printf("\n");

    i = get_input();
	system("clear");
    switch (i) {
        case 1:
			printf("[Borrow a DVD]\n");
            borrow_menu();
            pause();
            main_menu();
            break;
        case 2:
		    printf("[Return a DVD]\n");
            return_menu();
            pause();
            main_menu();
            break;
        case 3:
            print_dvds();
            pause();
            main_menu();
            break;
        case 4:
            print_borrs();
            pause();
            main_menu();
            break;
        case 5:
            print_loans();
            pause();
            main_menu();
            break;
        case 6:
            printf("\nDesigned and coded by Sean \"Talyn\" Handley (320097@swan.ac.uk), December 2005.\n(Some code used with permission of Andy Gimblett.)\n\n");
            pause();
            main_menu();
            break;
        case 7:
            printf("\nGoodbye :)\n\n");
            break;
        default:
            printf("\nInvalid option.\n");
            pause();
            main_menu();
    }
}

void show_ui(int maxdvd) {
    dvdlimit = maxdvd;
    system("clear"); /* I know this is bad practice *hangs head in shame* :( */
    main_menu();
}
